function qiaSetAsImage() {
    var path = $(this).parent().find('img').attr("src");
    PUNBB.pun_bbcode.insert_text('[img]' +  path, '[/img]');
    return false;
}

function qiaSetAsUrl() {
    var title = prompt(lang_quadric_image_assistant_url_title);
    if (title != undefined) {
        var path = $(this).parent().find('img').attr("src").match(/(.*)\/t\/(.*)/);
        PUNBB.pun_bbcode.insert_text('[url=' +  path[1] + '/' + path[2] + ']' + title, '[/url]');
    }
    return false;
}

function qiaSetDelete() {
    if (confirm(lang_quadric_image_assistant_confirm_delete)) {
        var img = $(this).closest('.qia-clickable').find('img').attr('src');
        img = img.substring(img.lastIndexOf('/') + 1);
        var cur_block = $(this).closest('.qia-clickable');
        cur_block.html('<img src="' + quadric_image_assistant_ext_url + '/assets/ajax-loader.gif" /><p><span>' + lang_quadric_image_assistant_deleting + '</span></p>');
        $.getJSON(quadric_image_assistant_base_url + '/misc.php?qia_upload', { 'delete': img }, function(json){
            cur_block.remove();
            if ($('.qia-clickable').length <= 1) {
                $('#qia-exist-info').remove();
                $('#qia-container').css('clear', 'none');
            }
        });
    }

    return false;
}

$(function() {
    var uploader = new plupload.Uploader({
		runtimes : 'gears,html5,flash,silverlight,browserplus',
		browse_button : 'qia-pick-files',
		container : 'qia-container',
		max_file_size : quadric_image_assistant_max_file_size / 1024 + 'Kb',
		chunk_size : '100kb',
		url : quadric_image_assistant_base_url + '/misc.php?qia_upload',
		flash_swf_url : quadric_image_assistant_ext_url + '/assets/plupload.flash.swf',
		silverlight_xap_url : quadric_image_assistant_ext_url + '/assets/plupload.silverlight.xap',
		resize : {width : quadric_image_assistant_max_width, height : quadric_image_assistant_max_height, quality : 70},
        filters : [
            {title : "Image files", extensions : quadric_image_assistant_allowed_images}
        ]
	});

    uploader.bind('Error', function(up, err) {
        console.log('Error', err);
    });

    uploader.bind('BeforeUpload', function(up, file) {
        file.name = file.name.toLowerCase();
    });

	uploader.bind('FilesAdded', function(up, files) {
        $('#qia-container').css('clear', 'both');
        $('#qia-description').hide();
		if ($('#qia-error').length > 0)
			$('#qia-error').remove();
		$.each(files, function(i, file) {
			if (file.size < quadric_image_assistant_max_file_size ) {
				var ext = file.name.substring(file.name.lastIndexOf('.') + 1);
				if (quadric_image_assistant_allowed_images.toLowerCase().search(ext.toLowerCase()) !=-1) {
					file.name = file.id + '.' + ext; 
					$('#qia-container').before('<div class="qia-clickable" id="qia-img-'+file.id+'"><img src="' + quadric_image_assistant_ext_url + '/assets/ajax-loader.gif" /><p id="qia-desc-'+file.id+'"><span id="progr'+file.id+'">0%</span><span>(' + plupload.formatSize(file.size) + ')</span></p></div>');
				}
				else {
					showError(lang_quadric_image_assistant_invalid_extension + file.name);
				}
			}
			else {
				showError(file.name + ' ('+ file.size +') - ' + lang_quadric_image_assistant_max_file_size + '(' + quadric_image_assistant_max_file_size  + ')');
			}
		});
		setTimeout(function(){uploader.start();	} , 300);
	});
	
	uploader.bind('FileUploaded',function(up, file, res) { 
		var obj = jQuery.parseJSON(res.response);
		if (obj.result == 1) {
			/*$('#qia-img-'+file.id).remove();
			PUNBB.pun_bbcode.insert_text('[img]' + ext_url + '/' + obj.thumb,'[/img]');*/
			var img = obj.thumb.substring(obj.thumb.lastIndexOf('/') + 1);
            $('#qia-desc-'+file.id).remove();
            $('#qia-img-'+file.id).find('img').css('width', '100px').attr('src', quadric_image_assistant_base_url + '/' + obj.thumb);
            
            $('#qia-img-'+file.id).append('<span class="qia-delete"><a id="qia-delete-' + file.id + '" href="#"></a></span>');
            $('#qia-img-'+file.id).append('<span class="qia-url"><a id="qia-url-' + file.id + '" href="#"></a></span>');
            $('#qia-img-'+file.id).append('<span class="qia-image"><a id="qia-image-' + file.id + '" href="#"></a></span>');
            
            $('#qia-image-' + file.id).parent().click(qiaSetAsImage);
            $('#qia-url-' + file.id).parent().click(qiaSetAsUrl);
            $('#qia-delete-' + file.id).parent().click(qiaSetDelete);
		}
		else {
			showError(obj.error.message);
			$('#qia-img-'+file.id).remove();
		}
	 });
	 
	uploader.bind('UploadProgress', function(up, file) {
		if (file.status == plupload.DONE) {
			file.percent = 100;
		}
		$('#progr' + file.id).html(file.percent + "%");
	});
	
	function showError(error) {
		if ($('#qia-error').length == 0)
			$('.frm-form').prepend('<div id="qia-error" class="ct-box error-box"><ul class="error-list"></ul></div>');
		$('#qia-error ul').append('<li class="warn">' + error + '</li>');
	}
	
	uploader.init();
});