<?php

/**
 * Upload image or use already uploaded and put into a post as bbcode tag
 * Extension for PunBB 1.4
 *
 * quadric_image_assistant
 * @copyright (C) 2011 quadric quadmachine@wp.pl
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * 
 * Extension for PunBB (C) 2011 PunBB
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 */

// Make sure no one attempts to run this script "directly"
if (!defined('FORUM'))
	exit;

$errors = array ();
	
if (isset($_POST['qia_form_sent']))
{
	$form = array_map('trim', $_POST['form']);	
	
	if (!isset($form['o_quadric_image_assistant_enable']) || $form['o_quadric_image_assistant_enable'] != '1') {
        $form['o_quadric_image_assistant_enable'] = '0';
    }

	if (!isset($form['o_quadric_image_assistant_allow_image']) || forum_trim($form['o_quadric_image_assistant_allow_image']) == '')
		$errors[] = $lang_quadric_image_assistant['Error empty allow image'];	
	
	if (isset($form['o_quadric_image_assistant_max_file_size']) && forum_trim($form['o_quadric_image_assistant_max_file_size']) != '')
		if (!preg_match('/[^0-9]/',$form['o_quadric_image_assistant_max_file_size']))
			if ($form['o_quadric_image_assistant_max_file_size'] > 10)
				$form['o_quadric_image_assistant_max_file_size'] = intval($form['o_quadric_image_assistant_max_file_size']);
			else 
				$errors[] = $lang_quadric_image_assistant['Error short filesize'];
		else 
			$errors[] = $lang_quadric_image_assistant['Error filesize not numeric'];
	else
		$errors[] = $lang_quadric_image_assistant['Error empty filesize'];
		
	if (isset($form['o_quadric_image_assistant_max_width']) && forum_trim($form['o_quadric_image_assistant_max_width']) != '')
		if (!preg_match('/[^0-9]/',$form['o_quadric_image_assistant_max_width']))
			if ($form['o_quadric_image_assistant_max_width'] > 1)
				$form['o_quadric_image_assistant_max_width'] = intval($form['o_quadric_image_assistant_max_width']);
			else 
				$errors[] = $lang_quadric_image_assistant['Error short width'];
		else 
			$errors[] = $lang_quadric_image_assistant['Error width not numeric'];
	else
		$errors[] = $lang_quadric_image_assistant['Error empty width'];
		
	if (isset($form['o_quadric_image_assistant_max_height']) && forum_trim($form['o_quadric_image_assistant_max_height']) != '')
		if (!preg_match('/[^0-9]/',$form['o_quadric_image_assistant_max_height']))
			if ($form['o_quadric_image_assistant_max_height'] > 1)
				$form['o_quadric_image_assistant_max_height'] = intval($form['o_quadric_image_assistant_max_height']);
			else 
				$errors[] = $lang_quadric_image_assistant['Error short height'];
		else 
			$errors[] = $lang_quadric_image_assistant['Error height not numeric'];
	else
		$errors[] = $lang_quadric_image_assistant['Error empty height'];
		
		
	if (isset($form['o_quadric_image_assistant_thumb_width']) && forum_trim($form['o_quadric_image_assistant_thumb_width']) != '')
		if (!preg_match('/[^0-9]/',$form['o_quadric_image_assistant_thumb_width']))
			if ($form['o_quadric_image_assistant_thumb_width'] > 1)
				$form['o_quadric_image_assistant_thumb_width'] = intval($form['o_quadric_image_assistant_thumb_width']);
			else 
				$errors[] = $lang_quadric_image_assistant['Error thumb short width'];
		else 
			$errors[] = $lang_quadric_image_assistant['Error thumb width not numeric'];
	else
		$errors[] = $lang_quadric_image_assistant['Error thumb empty width'];
		
	
	if (isset($form['o_quadric_image_assistant_thumb_height']) && forum_trim($form['o_quadric_image_assistant_thumb_height']) != '')
		if (!preg_match('/[^0-9]/',$form['o_quadric_image_assistant_thumb_height']))
			if ($form['o_quadric_image_assistant_thumb_height'] > 1)
				$form['o_quadric_image_assistant_thumb_height'] = intval($form['o_quadric_image_assistant_thumb_height']);
			else 
				$errors[] = $lang_quadric_image_assistant['Error thumb short height'];
		else 
			$errors[] = $lang_quadric_image_assistant['Error thumb height not numeric'];
	else
		$errors[] = $lang_quadric_image_assistant['Error thumb empty height'];	

	if (empty($errors)) {

		$qia_config = array(
			'o_quadric_image_assistant_allow_image'		=> $form['o_quadric_image_assistant_allow_image'],
			'o_quadric_image_assistant_max_file_size'	=> $form['o_quadric_image_assistant_max_file_size'],
			'o_quadric_image_assistant_max_width'		=> $form['o_quadric_image_assistant_max_width'],
			'o_quadric_image_assistant_max_height'		=> $form['o_quadric_image_assistant_max_height'],
			'o_quadric_image_assistant_thumb_width'		=> $form['o_quadric_image_assistant_thumb_width'],
			'o_quadric_image_assistant_thumb_height'	=> $form['o_quadric_image_assistant_thumb_height'],
			'o_quadric_image_assistant_enable'			=> $form['o_quadric_image_assistant_enable']
		);
		foreach ($qia_config as $key => $value)
		{
			$query = array(
				'UPDATE'	=> 'config',
				'SET'		=> 'conf_value=\''.$forum_db->escape($value).'\'',
				'WHERE'		=> 'conf_name=\''.$forum_db->escape($key).'\''
			);
			
			$forum_db->query_build($query);
		}		

		if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
			require FORUM_ROOT . 'include/cache.php';

		generate_config_cache();
			
		redirect(forum_link('admin/settings.php?section=quadric_image_assistant'), $lang_quadric_image_assistant['QIA redirect']);
	
	}
}

// Setup breadcrumbs
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array($lang_admin_common['Settings'], forum_link($forum_url['admin_settings_setup'])),
	array($lang_quadric_image_assistant['Label images'], forum_link('admin/settings.php?section=quadric_image_assistant'))
);

$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;
define('FORUM_PAGE_SECTION', 'settings');
define('FORUM_PAGE', 'admin-quadric-image-assistant');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

// If there were any errors, show them
if (!empty($errors))
{
    $forum_page['errors'] = array();
    foreach ($errors as $cur_error)
        $forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
?>
    <div class="ct-box error-box">
        <h2 class="warn hn"><?php echo $lang_quadric_image_assistant['QIA errors'] ?></h2>
        <ul class="error-list">
            <?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
        </ul>
    </div>
<?php
}
?>
	<div class="main-content main-frm">
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link('admin/settings.php?section=quadric_image_assistant') ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link('admin/settings.php?section=quadric_image_assistant')) ?>" />
				<input type="hidden" name="qia_form_sent" value="1" />
			</div>
			<div class="content-head">
				<h2 class="hn"><span><?php echo $lang_quadric_image_assistant['QIA general'] ?></span></h2>
			</div>
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong><?php echo  $lang_quadric_image_assistant['QIA general legend'] ?></strong></legend>
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box checkbox">
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="form[o_quadric_image_assistant_enable]" value="1"<?php if ($forum_config['o_quadric_image_assistant_enable'] == '1') echo ' checked="checked"' ?> /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>"><span><?php echo $lang_quadric_image_assistant['Enable'] ?></span> <?php echo $lang_quadric_image_assistant['Enable help'] ?></label>
					</div>
				</div>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_quadric_image_assistant['Allowed images'] ?></span><small><?php echo $lang_quadric_image_assistant['Allowed images help'] ?></small></label><br />
						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[o_quadric_image_assistant_allow_image]" size="45" maxlength="255" value="<?php echo isset($form['o_quadric_image_assistant_allow_image']) ? forum_htmlencode($form['o_quadric_image_assistant_allow_image']) : forum_htmlencode($forum_config['o_quadric_image_assistant_allow_image']) ?>" /></span>
					</div>
				</div>
		
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_quadric_image_assistant['Max file size'] ?></span><small><?php echo $lang_quadric_image_assistant['Max file size help'] ?></small></label><br />
						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[o_quadric_image_assistant_max_file_size]" size="25" maxlength="255" value="<?php echo isset($form['o_quadric_image_assistant_max_file_size']) ? forum_htmlencode($form['o_quadric_image_assistant_max_file_size']) : forum_htmlencode($forum_config['o_quadric_image_assistant_max_file_size']) ?>" /></span>
					</div>
				</div>	
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_quadric_image_assistant['Max img size'] ?></span><small><?php echo $lang_quadric_image_assistant['Max img size help'] ?></small></label><br />
						<span class="fld-input"><?php echo $lang_quadric_image_assistant['Width'] ?> <input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[o_quadric_image_assistant_max_width]" size="10" maxlength="10" value="<?php echo isset($form['o_quadric_image_assistant_max_width']) ? forum_htmlencode($form['o_quadric_image_assistant_max_width']) : forum_htmlencode($forum_config['o_quadric_image_assistant_max_width']) ?>" />&nbsp;&nbsp; <?php echo $lang_quadric_image_assistant['Height'] ?> <input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[o_quadric_image_assistant_max_height]" size="10" maxlength="10" value="<?php echo isset($form['o_quadric_image_assistant_max_height']) ? forum_htmlencode($form['o_quadric_image_assistant_max_height']) : forum_htmlencode($forum_config['o_quadric_image_assistant_max_height']) ?>" /></span>
					</div>
				</div>				
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_quadric_image_assistant['Thumbs size'] ?></span><small><?php echo $lang_quadric_image_assistant['Thumbs size help'] ?></small></label><br />
						<span class="fld-input"><?php echo $lang_quadric_image_assistant['Width'] ?> <input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[o_quadric_image_assistant_thumb_width]" size="10" maxlength="10" value="<?php echo isset($form['o_quadric_image_assistant_thumb_width']) ? forum_htmlencode($form['o_quadric_image_assistant_thumb_width']) : forum_htmlencode($forum_config['o_quadric_image_assistant_thumb_width']) ?>" />&nbsp;&nbsp; <?php echo $lang_quadric_image_assistant['Height'] ?> <input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[o_quadric_image_assistant_thumb_height]" size="10" maxlength="10" value="<?php echo isset($form['o_quadric_image_assistant_thumb_height']) ? forum_htmlencode($form['o_quadric_image_assistant_thumb_height']) : forum_htmlencode($forum_config['o_quadric_image_assistant_thumb_height']) ?>" /></span>
					</div>
				</div>
												
			</fieldset>
			<div class="frm-buttons">
				<span class="submit"><input type="submit" name="save" value="<?php echo $lang_admin_common['Save changes'] ?>" /></span>
			</div>
		</form>
	</div>
	