<?php

/**
 * Upload image or use already uploaded and put into a post as bbcode tag
 * Extension for PunBB 1.4
 *
 * quadric_image_assistant
 * @copyright (C) 2011 quadric quadmachine@wp.pl
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * 
 * Extension for PunBB (C) 2011 PunBB
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 */

// Make sure no one attempts to run this script "directly"
if (!defined('FORUM'))
	exit;

if (file_exists($ext_info['path'] . '/lang/' . $forum_user['language'] . '/' . $ext_info['id'] . '.php')) {
    include $ext_info['path'] . '/lang/' . $forum_user['language'] . '/' . $ext_info['id'] . '.php';
} else {
    include $ext_info['path'] . '/lang/English/quadric_image_assistant.php';
}

$query = array(
    'SELECT'	=> 'af.id, af.file_path',
    'FROM'		=> 'qia_images as af',
    'WHERE'     => 'af.owner_id = ' . $forum_user['id']
);

$result_add = $forum_db->query_build($query) or error(__FILE__, __LINE__);

$images = array();
while($cur_record = $forum_db->fetch_assoc($result_add))
{
    $fnp = explode('/', $cur_record['file_path']);
    $fn = array_pop($fnp);
    $fnp[] = 't';
    $fnp[] = $fn;
    $cur_record['file_path'] = implode('/', $fnp);
    $images[$fn] = $cur_record['file_path'];
}
?>
<div class="sf-box text">
    <div id="qia-block" style="margin: 0 0 0 1em;">
        <?php if (isset($images)): ?> 
        <p id="qia-exist-info"><?php echo $lang_quadric_image_assistant['Exist images'] ?></p>
        <div id="qia-block-gallery">
            <?php foreach ($images as $id => $img) : ?>
            <div class="qia-clickable">
                <span><!-- --></span>
                <img class="shadow" style="cursor:default" width="100px" src="<?php echo $base_url . '/' . $img ?>" />

                <span class="qia-delete">
                    <a id="qia-delete-<?php echo $id ?>" href="#" title="<?php echo $lang_quadric_image_assistant['Delete file'] ?>"></a>
                </span>

                <span class="qia-image">
                    <a id="qia-image-<?php echo $id ?>" href="#" title="<?php echo $lang_quadric_image_assistant['Delete file'] ?>"></a>
                </span>

                <span class="qia-url">
                    <a id="qia-url-<?php echo $id ?>" href="#" title="<?php echo $lang_quadric_image_assistant['Delete file'] ?>"></a>
                </span>

            </div>
            <?php endforeach; ?>
        </div>
        <?php else : ?>
        <div id="qia-description">
            <p><?php echo sprintf($lang_quadric_image_assistant['No uploaded images'], $forum_config['o_quadric_image_assistant_max_file_size'] / 1024 )?></p>
        </div>
        <?php endif ?>
    </div>
</div>

<script>
$(function() {
    $('#qia-block div.qia-clickable .qia-image').click(qiaSetAsImage);
    $('#qia-block div.qia-clickable .qia-url').click(qiaSetAsUrl);
    $('#qia-block div.qia-clickable .qia-delete').click(qiaSetDelete);
});
</script>

<?php

die();