<?php

/**
 * Upload image or use already uploaded and put into a post as bbcode tag
 * Extension for PunBB 1.4
 *
 * quadric_image_assistant
 * @copyright (C) 2011 quadric quadmachine@wp.pl
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * 
 * Extension for PunBB (C) 2011 PunBB
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * 
 * Based on code hcs_image_uploader Copyright (C) 2010 hcs hcs@mail.ru
 * Licence http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * 
 * Based on code upload.php Copyright 2011, Moxiecode Systems AB
 * Released under GPL License.
 * License: http://www.plupload.com/license
 * Contributing: http://www.plupload.com/contributing  
 */

// Make sure no one attempts to run this script "directly"
if (!defined('FORUM'))
	exit;

if (file_exists($ext_info['path'] . '/lang/' . $forum_user['language'] . '/' . $ext_info['id'] . '.php')) {
    include $ext_info['path'] . '/lang/' . $forum_user['language'] . '/'.$ext_info['id'] . '.php';
} else {
    include $ext_info['path'] . '/lang/English/quadric_image_assistant.php';
}

require $ext_info['path'] . '/../pun_attachment/include/attach_func.php';

// HTTP headers for no cache etc
header('Content-type: text/plain; charset=UTF-8');
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

$uploadDir = 'img/m/' . $forum_user['id'];
$targetDir = FORUM_ROOT . $uploadDir;
	
if (!file_exists(FORUM_ROOT . $uploadDir)) {
    mkdir(FORUM_ROOT . $uploadDir, 0775, true);
}

// 5 minutes execution time
@set_time_limit(5 * 60);
// usleep(5000);

if (isset($_GET['delete'])) {
    
    $userId = $forum_user['id'];
    $fileName = $_GET['delete'];
    
    //echo $uploadDir . '/' . $forum_db->escape($_GET['delete']);
    
    $query = array(
        'SELECT'	=> 'af.id, af.file_path',
        'FROM'		=> 'qia_images as af',
        'WHERE'     => 'af.owner_id = ' . $userId . ' and af.file_path = \'' . $uploadDir . '/' . $forum_db->escape($fileName) . '\''
    );

    $foundImageRes = $forum_db->query_build($query);
    
    if ($forum_db->num_rows($foundImageRes)) {
        $query = array(
            'DELETE'	=> 'qia_images',
            'WHERE'		=> 'file_path = \'' . $uploadDir . '/' . $forum_db->escape($fileName) . '\''
        );
        $forum_db->query_build($query);

        @unlink($targetDir . '/' . $_GET['delete']);
        @unlink($targetDir . '/t/' . $_GET['delete']);
    }
    die('{"jsonrpc" : "2.0", "deleted" : "'.$_GET['delete'].'", "id" : "id"}');
}

// Get parameters
$chunk = isset($_REQUEST["chunk"]) ? $_REQUEST["chunk"] : 0;
$chunks = isset($_REQUEST["chunks"]) ? $_REQUEST["chunks"] : 0;
$fileName = isset($_REQUEST["name"]) ? $_REQUEST["name"] : '';

$orgFileName = isset($_FILES["file"]["name"]) ? $_FILES["file"]["name"] : '';
$file_ext = attach_get_extension($fileName);

if ($fileName!='' && strpos( strtolower($forum_config['o_quadric_image_assistant_allow_image']),$file_ext) === false ) {
    die('{"jsonrpc" : "2.0", "name" : "'.$fileName.'", "error" : {"code": 105, "message": "'.$lang_quadric_image_assistant['Error extension invalid'].$fileName.'"}, "id" : "id"}');
}

// Clean the fileName for security reasons
$fileName = preg_replace('/[^\w\._]+/', '', $fileName);

if (is_dir($targetDir) && ($user_dir = opendir($targetDir))) {
    closedir($user_dir);
} else
    die('{"jsonrpc" : "2.0", "error" : {"code": 100, "message": "Failed to open directory '.$targetDir.'."}, "id" : "id"}');

// Look for the content type header
if (isset($_SERVER["HTTP_CONTENT_TYPE"]))
    $contentType = $_SERVER["HTTP_CONTENT_TYPE"];

if (isset($_SERVER["CONTENT_TYPE"]))
    $contentType = $_SERVER["CONTENT_TYPE"];

if (strpos($contentType, "multipart") !== false) {
	if (isset($_FILES['file']['tmp_name']) && is_uploaded_file($_FILES['file']['tmp_name'])) {
		// Open temp file
		$out = fopen($targetDir . DIRECTORY_SEPARATOR . $fileName, $chunk == 0 ? "wb" : "ab");
		if ($out) {
			// Read binary input stream and append it to temp file
			$in = fopen($_FILES['file']['tmp_name'], "rb");

			if ($in) {
				while ($buff = fread($in, 4096))
					fwrite($out, $buff);
			} else
				die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');
			fclose($in);
			fclose($out);
            //unlink($_FILES['file']['tmp_name']);
		} else
			die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
	} else
		die('{"jsonrpc" : "2.0", "error" : {"code": 103, "message": "Failed to move uploaded file."}, "id" : "id"}');
} else {
	// Open temp file
	$out = fopen($targetDir . DIRECTORY_SEPARATOR . $fileName, $chunk == 0 ? "wb" : "ab");
	if ($out) {
		// Read binary input stream and append it to temp file
		$in = fopen("php://input", "rb");

		if ($in) {
			while ($buff = fread($in, 4096))
				fwrite($out, $buff);
		} else
			die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');

		fclose($in);
		fclose($out);
	} else
		die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
}

// Return JSON-RPC response
if ( ( $chunk == 0 && $chunks == 0 ) || ( $chunk + 1 == $chunks ) ) {
    
    $fileSize = filesize($targetDir . '/' . $fileName);

    // file is biggest			
    if ($fileSize > $forum_config['o_quadric_image_assistant_max_file_size']) {
        @unlink($targetDir . '/' . $fileName);
        die('{"jsonrpc" : "2.0", "name" : "'.$fileName.'", "error" : {"code": 108, "message": "'.$lang_quadric_image_assistant['Error filesize is big'] . $fileName . '"}, "id" : "id"}');
    }

    
    
    // Save to DB
    $attach_record = array(
        'owner_id' => $forum_user['id'],
        'filename' => '\''.$forum_db->escape($orgFileName).'\'', 
        'file_ext' => '\''.$forum_db->escape($file_ext).'\'', 
        'file_mime_type' => '\''.attach_create_mime($file_ext).'\'', 
        'file_path' => '\''.$forum_db->escape($uploadDir.'/'.$fileName).'\'', 
        'size' => $fileSize,
        'uploaded_at' => time()
    );
    $attach_query = array(
        'INSERT'	=>	implode(',', array_keys($attach_record)),
        'INTO'		=>	'qia_images',
        'VALUES'	=>	implode(',', array_values($attach_record))
    );
    $forum_db->query_build($attach_query) or error(__FILE__, __LINE__);

    $thumbDir = $targetDir . '/t';
    
    if (!file_exists($thumbDir)) {
        mkdir($thumbDir, 0775);
    }

    if (QIA_make_thumbnail($targetDir.'/' . $fileName, $thumbDir.'/' . $fileName, $forum_config['o_quadric_image_assistant_thumb_width'], $forum_config['o_quadric_image_assistant_thumb_height']))
        die('{"jsonrpc" : "2.0", "result" : 1, "id" : "' . $forum_db->insert_id() . '", "thumb" : "' . $uploadDir.'/t/' . $fileName.'", "name" : "' . $fileName . '"}');
    else
        die('{"jsonrpc" : "2.0", "name" : "' . $fileName . '", "error" : {"code": 105, "message": "' . $lang_quadric_image_assistant['Error is not image'] . $fileName . '"}, "id" : "id"}');
}

die('{"jsonrpc" : "2.0", "result" : null, "id" : "id"}');

function QIA_make_thumbnail($orig_fname, $thumb_fname, $thumb_width = 100, $thumb_height = 100) {
	$rgb = 0xFFFFFF;
	$quality = 100;
	$size = @getimagesize ( $orig_fname );
	$src_x = $src_y = 0;
	
	if ($size === false)
		return false;
	
	$format = strtolower ( substr ( $size ['mime'], strpos ( $size ['mime'], '/' ) + 1 ) );
	$icfunc = "imagecreatefrom" . $format;
	if (! function_exists ( $icfunc ))
		return false;
	
	$orig_img = $icfunc ( $orig_fname );
	if (($size [0] <= $thumb_width) && ($size [1] <= $thumb_height)) {
		// use original size
		$width = $size ['0'];
		$height = $size ['1'];
	} else {
		$width = $thumb_width;
		$height = $thumb_height;
		
		// calculate fit ratio
		$ratio_width = $size ['0'] / $thumb_width;
		$ratio_height = $size ['1'] / $thumb_height;
		
		if ($ratio_width < $ratio_height) {
			$width = $size ['0'] / $ratio_height;
			$height = $thumb_height;
		} else {
			$width = $thumb_width;
			$height = $size ['1'] / $ratio_width;
		}
	}
	
	$thum_img = imagecreatetruecolor ( $width, $height );
	imagefill ( $thum_img, 0, 0, $rgb );
	imagecopyresampled ( $thum_img, $orig_img, 0, 0, $src_x, $src_y, $width, $height, $size [0], $size [1] );
	
	imagejpeg ( $thum_img, $thumb_fname, $quality );
	flush ();
	imagedestroy ( $orig_img );
	imagedestroy ( $thum_img );
	return true;
}